$('#tutorial').on('click', function () {
    $(document).ready(async function () {
        const driver = new Driver({
            doneBtnText: 'Sair',
            closeBtnText: 'Fechar',
            nextBtnText: 'Próximo',
            prevBtnText: 'Anterior',
            allowClose: false
        });
        driver.defineSteps([

            {
                element: '#btnFiltros',
                popover: {
                    title: 'Botão Filtros',
                    description: 'Clique aqui para filtrar a consulta.',
                    position: 'right'
                }
            },
            {
                element: '#btnNovoRepresentante',
                popover: {
                    title: 'Botão Incluir',
                    description: 'Clique aqui para iniciar o cadastro de um representante.',
                    position: 'right'
                }
            },
            {
                element: '#tabelaRepresentante',
                popover: {
                    title: 'Tabela Representante',
                    description: 'Aqui estão os dados dos representantes cadastrados.',
                    position: 'top'
                }
            }
        ]);
        driver.start();
    });
});
$(document).ready(async function () {
    const permissaoUsuarioLogado = await permissaoAcessos("REPRESENTANTE");

    $('#txtRepresentante').autocompleta(4, `JSON={ "tabela":"represen", "camposSelect":[ "codrep chave", "nome descricao"], "where": null}`);
    $('#btnRepresentante').pesquisa_serverside(['#txtRepresentante'], ['CODREP'], ['NOME'], '{"tabela":"represen", "camposSelect":[ "CODREP", "NOME"], "where": null}', 'Pesquisa Representante');
    $('#btnARepresentante').on('click', function () {
        $('#txtRepresentante').val('');
    });

    $('#btnFiltros').on('click', function () {
        $('#modal-filtros').modal('show');
    });

    $('#btnNovoRepresentante').on('click', function () {
        if (permissaoUsuarioLogado.INCLUI == 'S') {
            $('#modalEntidade').modal('show');
        } else {
            msgAlertaSemConfirmacao("Sem permissão para incluir!");
        }
    });

    $('#txtEntidade').autocompleta(4, `JSON={ "tabela":"entidade", "camposSelect":[ "codcli chave", "nome descricao"], "where": null}`);
    $('#btnEntidade').pesquisa('#txtEntidade', 'CODCLI', 'NOME', `/sisplan/funcoes/v1/pesquisa?JSON={ "tabela":"entidade", "camposSelect":[ "codcli", "nome"]}`, 'Pesquisa Entidade', 'entidade');
    $('#btnAEntidade').on('click', function () {
        $('#txtEntidade').val('');
    });

    $('#btnConfirmarEntidade').click(async function () {
        if ($('#txtEntidade').val() != '') {
            let entidade = pegaChave('#txtEntidade');
            window.location.href = `representante/${String(entidade)}`;
        } else {
            msgAlerta('Campo entidade deve ser preenchido.');
        }
    });
    
    function retornaBotaoOpcoes(data) {
        var retorno = '<div style="text-align:start;"> ' +
          '    <button class="btn btn-info btn-sm dropdown-toggle btnVerificaOpcoes" type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false"> ' +
          '      ' + data + ' ' +
          '    </button> ' +
          '    <div class="dropdown-menu"> ' +
          '     <button class="dropdown-item" type="button" title="Editar" id="btn-editar">Editar</button>     ' +
          '     <button class="dropdown-item" type="button" title="Excluir" id="btn-excluir">Excluir</button>  ' +
          '     <button class="dropdown-item" type="button" title="Anexos" id="btnAnexos">Gestão Documentos</button>     ' +
          '</div>';
        return retorno;
      };

    consultaNatureza();

    $('#btnConsultar').on('click', async function () {
        $('#modal-filtros').modal('hide');
        await consultaNatureza(true);s
    });

    $('#btnLimparFiltros').on('click', async function () {
        $('#txtRepresentante').val('');
    });

    async function consultaNatureza(bBotao = false) {
        try {
            $.LoadingOverlay("show");
            let response;
            let representante = pegaChave('#txtRepresentante') != '' ? ` AND CODREP = '${pegaChave('#txtRepresentante')}'` : '';

            if (bBotao) {
                response = await requisicao('GET', '/Sisplan/Funcoes/V1/pesquisa?', `JSON={ "tabela":"represen", "camposSelect":[ "codrep", "nome"],  "where": ["1=1 ${representante}"]}`, null);
            } else {
                response = await requisicao('GET', '/Sisplan/Funcoes/V1/pesquisa?', 'JSON={ "tabela":"represen", "camposSelect":[ "codrep", "nome"], "where": null}', null);
            }

            if (!response) {
                $.LoadingOverlay("hide");
                return;
            }

            let jsonStr = await response.json();
            if (response.status != 200) {
                $.LoadingOverlay("hide");
                msgErro(jsonStr.RESULT[0].mensagem);
                return;
            }

            $('#tabelaRepresentante').DataTable({
                destroy: true,
                lengthChange: false,
                serverside: true,

                "autoWidth": true,
                "data": jsonStr.RESULT[0],
                "columns": [{
                    "data": "CODREP"
                },
                {
                    "data": "NOME"
                },
                ],
                "columnDefs": [{
                    targets: [0], render: function (data, type, row) {
                        return retornaBotaoOpcoes(data);
                }
                }]
            });

            $.LoadingOverlay("hide");
        } catch (error) {
            console.error(error);
            $.LoadingOverlay("hide");
        }

    }

    $('#tabelaRepresentante').on('click', '#btn-editar', async function () {
        if (permissaoUsuarioLogado.ALTERA == 'S') {
            let data = $('#tabelaRepresentante').DataTable().row($(this).parents('tr')).data();
            let registroLiberado = await verificarRegistro('REPRESENTANTE', data.CODREP);
            if (registroLiberado) {
                window.location.href = `representante/${data.CODREP}`;
            }
        } else {
            msgAlertaSemConfirmacao("Sem permissão para alterar!");
        }
    });

    $("#tabelaRepresentante").on('click', "#btnAnexos", async function () {
        const data = $('#tabelaRepresentante').DataTable().rows($(this).parents('tr')).data();
    
        await abreModalAnexos(data[0].CODREP, data[0].NOME, 'REPRESENTANTE');
      })

    $('#tabelaRepresentante').on('dblclick', 'tr', async function () {
        if (permissaoUsuarioLogado.ALTERA == 'S') {
            let data = $('#tabelaRepresentante').DataTable().row($(this)).data();
            let registroLiberado = await verificarRegistro('REPRESENTANTE', data.CODREP);
            if (registroLiberado) {
                window.location.href = `representante/${data.CODREP}`;
            }
        } else {
            msgAlertaSemConfirmacao("Sem permissão para alterar!");
        }
    });

    $('#tabelaRepresentante').on('click', '#btn-excluir', async function () {
        if (permissaoUsuarioLogado.EXCLUI == 'S') {
            msgAlerta('Você realmente deseja excluir esse registro?', async () => {
                const data = $("#tabelaRepresentante").DataTable().row($(this).parents("tr"));
                await excluiRegistro(data);
            });
        } else {
            msgAlertaSemConfirmacao("Sem permissão para excluir!");
        }
    });

    async function excluiRegistro(data) {
        try {
            $.LoadingOverlay("show");
            try {
                let valorLinha = data.data();
                const tabela = 'REPRESEN';
                let response = await requisicao("DELETE", '/Sisplan/Cadastros/v1/representante?', `CODIGOREPRESENTANTE=${(valorLinha.CODREP)}&VALOR=${(valorLinha.CODREP)}&TABELA=${tabela}`, null);
                if (!response) {
                    return;
                }
                if (response.status != 200) {
                    let jsonStr = await response.json();
                    msgErro(jsonStr.mensagem);
                    return;
                }

                toastr.success("Exclusão efetuada com sucesso!", "Confirmação", {
                    toastClass: "success",
                    iconClasses: {
                        error: "alert-error",
                        info: "alert-info",
                        success: "alert-success",
                        warning: "alert-warning",
                    },
                    positionClass: "toast-top-center",
                    progressBar: true,
                    timeOut: 3000,
                    fadeOut: 1000,
                    onHidden() {
                        data.remove().draw(false);
                    },
                }).css({
                    "margin-top": "20%",
                    width: "500px",
                    "max-width": "500px",
                });

            } catch (error) {
                console.error(error);
            }
        } finally {
            $.LoadingOverlay("hide");
        }
    }
});